Cannot set parent to NULL in relation reference widget
Status: Closed

Priority: Normal

Assignee: Sebastian Dietrich

Category: Relations

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 22164

Description

Although the ``Allow null value`` option is checked if a child already has a parent, I cannot set that parent to NULL from the form.

Tested under Debian Stretch, QGIS 2.12.3 and Master.

I have attached data so that the issue is easily reproduced.

Related issues:

Related to QGIS Application - Bug report # 13970: Relation reference widget d... Closed 2015-12-10

Associated revisions

Revision 5f157a90 - 2016-02-26 12:03 AM - Sebastian Dietrich 

offer NULL value in relation reference widget if allowed (fixes #14162)

Revision e08130d7 - 2016-03-08 08:11 AM - Matthias Kuhn 

Merge pull request #2827 from SebDieBln/AllowNullInRelationRef

[Bugfix] offer NULL value in relation reference widget if allowed (fixes #14162)

History

#1 - 2016-02-05 06:18 AM - Denis Rouzaud

- Status changed from Open to Feedback

the null button is only displayed when read-only selector is used.

otherwise, first entry in the list should be the NULL value

#2 - 2016-02-05 08:48 AM - Giovanni Manghi

- Category changed from GUI to Relations

#3 - 2016-02-06 12:04 AM - Tudor Bărăscu

- File relations_bug.gif added

Hi and thanks for the info.
I understand that when the user has checked the Use a read-only line edit instead of a combobox box,  he has the opportunity to set the parent to NULL by

clicking on the X.

However, I am considering that as a workaround because if the Default setting (combobox) is used, and the Allow null value option is checked then there is

no way to select the NULL value from the combobox, and the user is restricted to the selection between other parents.

I'm attaching a GIF so that it's clearer.

#4 - 2016-02-21 03:35 AM - Sebastian Dietrich

- OS version deleted (Stretch)

- Operating System deleted (Debian)

- Status changed from Feedback to Open

Confirmed in current master (commit:4c63c85cca6b33150c2af67895a2083dc69a7c5d), but the behaviour changed a little:

Now the combobox does not contain a NULL entry at all, while before it contained one that was not selectable.

#5 - 2016-02-21 12:12 PM - Sebastian Dietrich

- % Done changed from 0 to 100

- Pull Request or Patch supplied changed from No to Yes

- Assignee set to Sebastian Dietrich

- Status changed from Open to In Progress

See PR 2827 for a solution.

#6 - 2016-03-07 11:12 PM - Anonymous

- Status changed from In Progress to Closed

Fixed in changeset commit:"e08130d716a34e13cba4518e4cc9ac56d82a93da".

Files

relations_bug.zip 196 KB 2016-01-24 Tudor Bărăscu

relations_bug.gif 813 KB 2016-02-05 Tudor Bărăscu
https://github.com/qgis/QGIS/pull/2827

